from django.db.backends.mysql.base import DatabaseWrapper
from django.db.backends.mysql.operations import DatabaseOperations
from django.db.models.fields import (
    AutoField, AutoFieldMeta, PositiveIntegerField)

DatabaseOperations.integer_field_ranges['PositiveAutoField'] = \
    DatabaseOperations.integer_field_ranges['PositiveIntegerField']
DatabaseOperations.cast_data_types['PositiveAutoField'] = \
    DatabaseOperations.cast_data_types['PositiveIntegerField']
DatabaseWrapper.data_types['PositiveAutoField'] = \
    'integer UNSIGNED AUTO_INCREMENT'


class PositiveAutoField(
        AutoField, PositiveIntegerField, metaclass=AutoFieldMeta):
    def get_internal_type(self):
        return 'PositiveAutoField'

    def rel_db_type(self, connection):
        return PositiveIntegerField().db_type(connection=connection)
