from django.utils.encoding import force_str
from django.utils.safestring import mark_safe
from django.utils.text import slugify as django_slugify
from unidecode import unidecode

_SLUG_TRANSTABLE = str.maketrans('./_', '---')


def slugify(input_data: str):
    'Powerup version of the original django slugify.'
    pass_one = unidecode(force_str(input_data))\
        .translate(_SLUG_TRANSTABLE)\
        .strip('-')
    pass_two = django_slugify(value=pass_one)
    return mark_safe(pass_two)
